﻿using System;
using System.Runtime.InteropServices;

namespace MetadataLib.Interop
{
    [ComImport, GuidAttribute(MetadataUtil.IID_IMetaDataAssemblyImport), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    interface IMetaDataAssemblyImport
    {
        uint GetAssemblyProps(uint mda,
                                out IntPtr ppbPublicKey,
                                out uint pcbPublicKey,
                                out uint pulHashAlgId,
                                [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 4)] char[] szName,
                                uint cchName,
                                out uint pchName,
                                out ASSEMBLYMETADATA pMetaData,
                                out uint pdwAssemblyFlags);

        uint GetAssemblyRefProps(uint mdar,
                                    ref IntPtr ppbPublicKeyOrToken,
                                    out uint pcbPublicKeyOrToken,
                                    [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 4)] char[] szName,
                                    uint cchName,
                                    out uint pchName,
                                    ref ASSEMBLYMETADATA pMetaData,
                                    ref IntPtr ppbHashValue,
                                    out uint pcbHashValue,
                                    out uint pdwAssemblyRefFlags);
        
        uint GetFileProps(uint mdf,
                            [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] char[] szName,
                            uint cchName,
                            out uint pchName,
                            out IntPtr ppbHashValue,
                            out uint pcbHashValue,
                            out uint pdwFileFlags);

        uint GetExportedTypeProps(uint mdct,
                                    [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] char[] szName,
                                    uint cchName,
                                    out uint pchName,
                                    out uint ptkImplementation,
                                    out uint ptkTypeDef,
                                    out uint pdwExportedTypeFlags);

        uint GetManifestResourceProps(uint mdmr,
                                        [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] char[] szName,
                                        uint cchName,
                                        out uint pchName,
                                        out uint ptkImplementation,
                                        out uint pdwOffset,
                                        out uint pdwResourceFlags);
        
        uint EnumAssemblyRefs(ref IntPtr phEnum,
                                [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] uint[] rAssemblyRefs,
                                uint cMax,
                                out uint pcTokens);

        uint EnumFiles(ref IntPtr phEnum,
                        [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] uint[] rFiles,
                        uint cMax,
                        out uint pcTokens);

        uint EnumExportedTypes(ref IntPtr phEnum,
                                [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] uint[] rExportedTypes,
                                uint cMax,
                                out uint pcTokens);

        uint EnumManifestResources(ref IntPtr phEnum,
                                    [MarshalAs(UnmanagedType.LPArray, SizeParamIndex = 2)] uint[] rManifestResources,
                                    uint cMax,
                                    out uint pcTokens);

        uint GetAssemblyFromScope(out uint ptkAssembly);
        
        uint FindExportedTypeByName([MarshalAs(UnmanagedType.LPWStr)] string szName,
                                        uint mdtExportedType,
                                        out uint ptkExportedType);

        uint FindManifestResourceByName([MarshalAs(UnmanagedType.LPWStr)] string szName,
                                        out uint ptkManifestResource);

        void CloseEnum(IntPtr hEnum);

        uint FindAssembliesByName([MarshalAs(UnmanagedType.LPWStr)] string szAppBase,
                                    [MarshalAs(UnmanagedType.LPWStr)] string szPrivateBin,
                                    [MarshalAs(UnmanagedType.LPWStr)] string szAssemblyName,
                                    object[] ppIUnk,
                                    uint cMax,
                                    out uint pcAssemblies);
    }

    [StructLayout(LayoutKind.Sequential)]
    struct ASSEMBLYMETADATA
    {
        public ushort usMajorVersion;
        public ushort usMinorVersion;
        public ushort usBuildNumber;
        public ushort usRevisionNumber;
        public IntPtr szLocale;
        public uint cbLocale;
        public IntPtr rProcessor;
        public uint ulProcessor;
        public IntPtr rOS;
        public uint ulOS;
    }
}